float4x4 matWorld;
float4x4 matWorldViewProj;
//float4x4 matMtl;

float4 vecSkill1;

 Texture entSkin1;

sampler colorSampler = sampler_state {
	texture = <entSkin1> ;
	magfilter = LINEAR;
	minfilter = LINEAR;
	mipfilter=LINEAR;
	AddressU = mirror;
	AddressV = mirror;
};


struct SMapVertexToPixel
{
    float4 Position     : POSITION;    
    float3 Position2D    : TEXCOORD0;
    float2 Tex : TEXCOORD1;
};

struct SMapPixelToFrame
{
    float4 Color : COLOR0; 
};

float4 encode(float fDist)
{
	const float4 bitSh	= float4(   256*256*256, 256*256,   256,         1);
	const float4 bitMsk = float4(   0,      1.0/256.0,    1.0/256.0,    1.0/256.0);

	float4 comp;
	comp	= fDist * bitSh;
	comp	= frac(comp);
	comp	-= comp.xxyz * bitMsk;
	return comp;
}

SMapVertexToPixel ShadowMapVertexShader( float4 inPos : POSITION, float2 InTex:TEXCOORD0)
{
    SMapVertexToPixel Output = (SMapVertexToPixel)0;
    
    Output.Position = mul(inPos, matWorldViewProj);
    Output.Position2D = Output.Position;
    
    
    float3 posWorld = mul(inPos, matWorld).xyz;
	 //Output.Position2D.x = distance(posWorld.xyz,float3(vecSkill1.x,vecSkill1.z,vecSkill1.y))/4000;
	 Output.Position2D.xyz = posWorld.xyz;
    
    Output.Tex = InTex;
    
    return Output;    
}

SMapPixelToFrame ShadowMapPixelShader(SMapVertexToPixel PSIn)
{
   SMapPixelToFrame Output = (SMapPixelToFrame)0;
 		
	//encode R32F to ARGB8888 so shader can be used on a wider range of hardware
	//Output.Color.wzyx = encode(PSIn.Position2D.x);
	Output.Color.wzyx = encode(
	distance(PSIn.Position2D.xyz,float3(vecSkill1.x,vecSkill1.z,vecSkill1.y))/(vecSkill1.w)
	);
	
   //handle simple 0->1 transparency
   clip(tex2D(colorSampler,PSIn.Tex).a-0.5);
	
	//Output.Color = tex2D(colorSampler,PSIn.Tex);
	
   return Output;
}

//------- Techniques --------


technique ShadowMap
{
    pass Pass0
    {
    	alphablendenable = false;
    	cullmode = CCW;
      VertexShader = compile vs_2_0 ShadowMapVertexShader();
      PixelShader = compile ps_2_0 ShadowMapPixelShader();
    }
}
