// Textures
texture mtlSkin1;
Texture TargetMap;

// Variables
float4 vecViewPort;
float4 vecSkill1;


sampler currentScene = sampler_state
{
	texture 		= (TargetMap);
	MinFilter = Linear;
	MagFilter = Linear;
	MipFilter = Linear;
	AddressU = Clamp;
   AddressV = Clamp;
};

sampler orgScene = sampler_state
{
	texture 		= (mtlSkin1);
	MinFilter = Linear;
	MagFilter = Linear;
	MipFilter = Linear;
	AddressU = Clamp;
   AddressV = Clamp;
};

static const int g_c_PixelOffsetSize = 13;


float2 PixelOffsets[g_c_PixelOffsetSize] =
{
	{ 0, -0.006 },
	{ 0, -0.005 },
	{ 0, -0.004 },
	{ 0, -0.003 },
	{ 0, -0.002 },
	{ 0, -0.001 },
	{ 0,  0.000 },
	{ 0,  0.001 },
	{ 0,  0.002 },	
	{ 0,  0.003 },
	{ 0,  0.004 },
	{ 0,  0.005 },
	{ 0,  0.006 },
};


float2 PixelOffset_fix = {0, 0.004};

static const float BlurWeights[g_c_PixelOffsetSize] =
{
	0.002216,
	0.008764,
	0.026995,
	0.064759,
	0.120985,
	0.176033,
	0.199471,
	0.176033,
	0.120985,
	0.064759,
	0.026995,
	0.008764,
	0.002216,
};


float4 main_PS(float2 Tex : TEXCOORD0) : COLOR0
{
	vecSkill1.x = 1;
	float4 color = 0;
	float depth = tex2D(currentScene,Tex).a;
	for(int i = 0; i < g_c_PixelOffsetSize; i++)
	{
		color += 1 * tex2D(currentScene,(Tex) + PixelOffsets[i] * vecSkill1.x * depth) * BlurWeights[i];	
	}
	
	float3 blurred = color.rgb;
	float3 ssao = tex2D(currentScene,Tex).rgb;
	//if(color.a > depth+0.0001) color.rgb = lerp(color.rgb,ssao,(color.a-(depth+0.0001)));
	if(color.a > depth+0.00001) color.rgb = lerp(color.rgb,ssao,0.5);
	//if(color.a > depth+0.0001)color.rgb -= (depth);
	//color.rgb = (1-color.rgb)*tex2D(orgScene,Tex);
	//color.rgb = tex2D(currentScene,Tex);
	
	color.a = depth;
	return color;
	
}

technique HBlur
{
	pass pass1
	{
		alphablendenable=false;
		Pixelshader = compile ps_2_0 main_PS();
	}
}