float4x4 matMtl;
float4x4 matWorldViewProj;

float4 vecSkill1;
float4 vecSkill5;
float4 vecViewPos;
float4 vecViewDir;
float4 vecViewPort;

texture sc_map_depthEncode_bmap;

sampler depthSampler = sampler_state 
{ 
   Texture = <sc_map_depthEncode_bmap>; 
   MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = LINEAR;
};


float decode(float4 vec)
{
		const float4 bitShifts = float4(1.0/(256.0*256.0*256.0), 1.0/(256.0*256.0), 1.0/256.0, 1);

		return dot(vec.xyzw , bitShifts);
}

float4 mainPS(float4 inTex:TEXCOORD0):COLOR0
{
	//get scene depth
	float depth = decode(tex2D(depthSampler,inTex.xy).wzyx);
	//depth = tex2D(depthSampler,inTex.xy).x;
	
	//compute world position
	float4 vp = float4(inTex.xy * float2(2, -2) - float2(1, -1), depth, 1);
   float4 v = mul(vp, matMtl);
   float3 position = v.xyz/v.w;
	
	//1-((PSIn.Position2D.z-vecSkill1.y)/vecSkill1.x) * ((PSIn.Position2D.z-vecSkill1.y)/vecSkill1.x);
	depth = depth/v.w;
	
	
	//scene depth
    float4 Color = (depth/vecSkill1.w);
    //float4 Color = (depth/1000);
    Color.r = (Color.r + Color.g + Color.b)/3;
    //
    
    //waterdepth
    float pixelYDepth=((position.y-vecSkill5.x)/vecSkill5.y+1);
	 //clamp values to 0,1
	 pixelYDepth=saturate(pixelYDepth);
	 Color.g = pixelYDepth;
    //
    
    //dof depth
    Color.b = 1-((depth-vecSkill1.y)/vecSkill1.x) * ((depth-vecSkill1.y)/vecSkill1.x);
    if(vecSkill1.z > 0) Color.b = vecSkill1.z;
	
	Color.g = 1; //hot fix, not final!
	
	return Color;
	
	
}

technique t1
{
	pass p0
	{
		PixelShader = compile ps_2_0 mainPS();
	}
}