float4x4 matWorldViewProj;

float NearPlane = 1;
float FarPlane = 50000;

texture entSkin1;
texture mtlSkin1;

sampler colorSampler = sampler_state
{
    Texture = (mtlSkin1);
    AddressU = WRAP;
    AddressV = WRAP;
    MagFilter = LINEAR;
    MinFilter = LINEAR;
    Mipfilter = LINEAR;
};
struct VS_IN
{
	float4 Position	:	POSITION;
	float3 Tex : TEXCOORD0;
};

struct VS_OUT
{
	float4 Position	:	POSITION;
	float3 Tex : TEXCOORD0;
	float2 wPos : TEXCOORD1;
};

VS_OUT parabol_VS(VS_IN IN)
{
	VS_OUT OUT;
	
	OUT.Position = mul(IN.Position, matWorldViewProj);
		
	OUT.Tex = IN.Tex;
	
	OUT.wPos.x = OUT.Position.z;
	OUT.wPos.y = OUT.Position.w;
	
	return OUT;
}

float4 parabol_PS(VS_OUT IN):COLOR0
{
	float2 front;
	front.x = IN.Tex.x / (IN.Tex.z + 1);
	front.y = IN.Tex.y / (IN.Tex.z + 1);
	front.x = .5f * front.x + .5f; //bias and scale to correctly sample a d3d texture
	front.y = -.5f * front.y + .5f;
	float4 color = 1;
	color.rgb = tex2D(colorSampler,front).rgb;
	
	return color;//float4(InPos.x/InPos.y,0,0,1);
}

technique parabol
{
	pass p0
	{
		VertexShader = compile vs_2_0 parabol_VS();
		PixelShader = compile ps_2_0 parabol_PS();
	}
}