float4x4 matWorldViewProj;
float4x4 matWorld;
float4x4 matMtl;

texture entSkin1;
texture mtlSkin1;

sampler colorSampler = sampler_state 
{ 
   Texture = <entSkin1>; 
   MinFilter = Linear;
	MagFilter = Linear;
	MipFilter = Linear;
};

sampler projTexSampler = sampler_state 
{ 
   Texture = <mtlSkin1>; 
   MinFilter = Linear;
	MagFilter = Linear;
	MipFilter = Linear;
};



void mainVS(
	in float4 inPos : POSITION,
	in float2 inTex : TEXCOORD0,
	out float4 outPos: POSITION,
	out float2 outTex : TEXCOORD0,
	out float4 outProjTex : TEXCOORD1
)
{
	outPosition = mul(inPos,matWorldViewProj);
	
	outTex = inTex;
	
	outProjTex = mul(mul(InPos,matWorld), matMtl);
}

float4 mainPS(
	float2 inTex : TEXCOORD0,
	float4 inProjTex : TEXCOORD1
):COLOR0
{
	float2 ProjectedTexCoords;
   ProjectedTexCoords[0] = inProjTex.x/inProjTex.w/2.0f +0.5f;
   ProjectedTexCoords[1] = -inProjTex.y/inProjTex.w/2.0f +0.5f;
   
   float4 finalColor = tex2D(colorSampler,inTex);
   
   return finalColor;
}

technique t1
{
	pass p0
	{
		VertexShader = compile vs_2_0 mainVS();
		PixelShader = compile ps_2_0 mainPS();
	}
}