Texture TargetMap; //scene
Texture mtlSkin1; //bumpmap (scene gets refracted by this)
Texture mtlSkin2; //depthmap (scene depth)
Texture mtlSkin3; //normal

matrix matWorldViewProj;
matrix matWorld;

float4 vecSkill1;
//float rayDepth = 0.011;
float rayDepth = 0.001; //depth
float rayDepth2 = 0.0; //normals
//float scatterOffset = -0.0673; // 0.071
//float2 scatterOffset = {-0.071,-0.071};
static const int scatterNum = 1;


float2 scatterOffset[1] = {
	-0.07,-0.07
	/*
	-0.078,-0.068,
	-0.068,-0.078,
	-0.058,-0.068,
	-0.068,-0.058,
	
	
	-0.058,-0.058,
	-0.078,-0.078,
	-0.078,-0.058,
	-0.058,-0.078,
	*/
};

float2 scatterOffset2[8] = {
	-0.078,-0.078,
	0.078,0.078,
	-0.078,0.078,
	0.078,-0.078,
	
	-0.038,-0.038,
	0.038,0.038,
	-0.038,0.038,
	0.038,-0.038,
};


sampler sceneSampler = sampler_state
{
   texture = (TargetMap);
   MinFilter = linear;
   MagFilter = linear;
   MipFilter = linear;
   AddressU = Clamp;
   AddressV = Clamp;
};

sampler bumpSampler = sampler_state
{
   texture = (mtlSkin1);
   MinFilter = linear;
   MagFilter = linear;
   MipFilter = linear;
};

sampler depthSampler = sampler_state
{
   texture = (mtlSkin2);
   MinFilter = point;
   MagFilter = point;
   MipFilter = point;
   AddressU = Clamp;
   AddressV = Clamp;
};

sampler normalSampler = sampler_state
{
   texture = (mtlSkin3);
   MinFilter = linear;
   MagFilter = linear;
   MipFilter = linear;
   AddressU = Clamp;
   AddressV = Clamp;
};

float4 giPS(float2 Tex : TEXCOORD0) : COLOR0 
{
	vecSkill1.x = 2; // ray scatter strength
	vecSkill1.y = 0.5; // ray scatter strength (blur)
	
	float depth = tex2D(depthSampler, Tex).r;//+tex2D(depthSampler, Tex).g/127;
	float depthC = depth;
	float3 normals = tex2D(normalSampler,Tex).xyz;
	
	float4 bump = tex2D(bumpSampler, Tex*600);
	bump = normalize(bump);
	float4 bump2 = tex2D(normalSampler,Tex);
	bump2 = normalize(bump2);
	//bump = lerp(bump,bump2,0.5); //use scene normals
	float2 mid = ((Tex) + bump.xy * 0.15f * depthC * vecSkill1.x);
	//float2 mid = ((Tex) + bump.xy * 0.15f * vecSkill1.x);
	
	//mid = Tex;
		
	float4 pixel = tex2D(sceneSampler, Tex);//mid+float2(scatterOffset[0].x*vecSkill1.x*depth, scatterOffset[0].y*vecSkill1.x*depth));
	float depth2 = 0;
	float depthBlur = 0;
	float ssao = 0;
	float ssaoRDY = 0;
	float3 gi = 0;
	float3 colorBCK = pixel.xyz;
	pixel.rgb = 0;
	float3 normals2 = 0;
	
	for(int i = 0; i < scatterNum; i++)
	{
		
		/*
		depth2 = tex2D(depthSampler, mid+float2(scatterOffset[i].x*vecSkill1.x*depth, scatterOffset[i].y*vecSkill1.x*depth)).r;
					//+ tex2D(depthSampler, mid+float2(scatterOffset[i].x*vecSkill1.x*depth, scatterOffset[i].y*vecSkill1.x*depth)).g/127;

		depthBlur = 0;
		if(depth2 - depth <= rayDepth) depthBlur += depth2;
		else {depthBlur += depth;}
		depthBlur = clamp(depthBlur,0,1);
		
		ssao = depthBlur - depth;
		if(ssao > 0.0001)	ssao = 1;
		
		//ssao = 1-ssao;
	*/			
		
		
		
		gi = tex2D(sceneSampler,mid+float2(scatterOffset[i].x*vecSkill1.x*depthC, scatterOffset[i].y*vecSkill1.x*depthC)).xyz;
		depth2 = tex2D(depthSampler, mid+float2(scatterOffset[i].x*vecSkill1.x*depthC, scatterOffset[i].y*vecSkill1.x*depthC)).r;
		normals2 = tex2D(normalSampler,mid+float2(scatterOffset[i].x*vecSkill1.x*depthC, scatterOffset[i].y*vecSkill1.x*depthC)).xyz;
		//gi = tex2D(sceneSampler,mid+float2(scatterOffset[i].x*vecSkill1.x, scatterOffset[i].y*vecSkill1.x)).xyz;
		//depth2 = tex2D(depthSampler, mid+float2(scatterOffset[i].x*vecSkill1.x, scatterOffset[i].y*vecSkill1.x)).r;
		
		//&& ((normals.r - normals2.r > rayDepth2 || normals.g - normals2.g > rayDepth2 || normals.b - normals2.b > rayDepth2)
		//	|| (normals.r - normals2.r < -rayDepth2 || normals.g - normals2.g < -rayDepth2 || normals.b - normals2.b < -rayDepth2))
		
		if(
		depth2 - depth <= rayDepth
		&& depth2 - depth >= -rayDepth
		&& depth2 - depth != 0
		&& ((normals.r - normals2.r > rayDepth2 || normals.g - normals2.g > rayDepth2 || normals.b - normals2.b > rayDepth2)
			|| (normals.r - normals2.r < -rayDepth2 || normals.g - normals2.g < -rayDepth2 || normals.b - normals2.b < -rayDepth2))
		)
		{
			if(gi.r > 0.9) pixel.r += gi.r;//*(depth2-depth)*100;
			if(gi.g > 0.9) pixel.g += gi.g;
			if(gi.b > 0.9) pixel.b += gi.b;
			//else pixel.rgb += 1;
			//pixel.rgb += gi;// - ((normals.r + normals.g + normals.b) - (normals2.r + normals2.g + normals2.b))/3;
			
			//pixel.rgb -= 1;
			
			//ssao += depth2-depth;
			/*
			giBlur = 0;
			for(int j = 0; j < scatterNum; j++)
			{
				giBlur += tex2D(sceneSampler,mid+float2(scatterOffset2[j].x*vecSkill1.y*depth, scatterOffset2[j].y*vecSkill1.y*depth)).xyz;
			}
			giBlur /= scatterNum;
			pixel.rgb += giBlur;
			*/	
		} 
		
		/*
		else
		{
			//pixel.rgb += colorBCK;
			pixel.rgb += 1;
			//ssao += depth;
		}
		*/
		
		/*
		depth2 = tex2D(depthSampler, mid+float2(scatterOffset[i].x*vecSkill1.x*depth, scatterOffset[i].y*vecSkill1.x*depth)).r;
		
		if(depth2 - depth <= rayDepth && depth2 - depth >= -rayDepth) pixel.rgb += depth2-depth;
		else pixel.rgb += depth;
		*/
		
		
		
		
		
		depthBlur = 0;
		if(depth2 - depth <= rayDepth) depthBlur += depth2;
		else {depthBlur += depth;}
		depthBlur = clamp(depthBlur,0,1);
		
		ssao = depthBlur - depth;
		if(ssao > 0.0001
		&& ((normals.r - normals2.r > rayDepth2 || normals.g - normals2.g > rayDepth2 || normals.b - normals2.b > rayDepth2)
			|| (normals.r - normals2.r < -rayDepth2 || normals.g - normals2.g < -rayDepth2 || normals.b - normals2.b < -rayDepth2))
		)	ssao = 1;
		
		ssaoRDY += ssao;
		
		
		
		
		
	}


	pixel.rgb /= scatterNum;
	//if(pixel.r+pixel.g+pixel.b <= 0.9) pixel.rgb = 1;
	//pixel.rgb *= pow(pixel.rgb,240);
	//pixel.rgb *= 8;
	
	//pixel.rgb = lerp(ssao,pixel.rgb,0.5);
	//pixel.rgb += tex2D(sceneSampler, Tex).xyz;
	//pixel.rgb = pow(pixel.rgb,2);
	pixel.a = 1-((ssaoRDY/scatterNum));
	
	//pixel.rgb = bump2;
	
	//pixel.rgb /= 2;
	
	//pixel.rgb = tex2D(sceneSampler, Tex*2).xyz*tex2D(normalSampler, Tex).xyz;
	//pixel.rgb = tex2D(sceneSampler, mid).xyz;
	return pixel;
}


technique ssao
{
	pass one
	{
		alphablendenable = false;
		PixelShader = compile ps_2_a giPS();
	}
}