// Textures
//texture entSkin1;
Texture TargetMap;
Texture mtlSkin1; //depth

// Variables
float4 vecViewPort;
float4 vecSkill1;
float rayDepth = 0.002;

sampler currentScene = sampler_state
{
	texture 		= (TargetMap);
	MinFilter = Linear;
	MagFilter = Linear;
	MipFilter = Linear;
	AddressU = Clamp;
   AddressV = Clamp;
};

sampler depthSampler = sampler_state
{
	texture 		= (mtlSkin1);
	MinFilter = point;
	MagFilter = point;
	MipFilter = point;
	AddressU = Clamp;
   AddressV = Clamp;
};

static const int g_c_PixelOffsetSize = 13;


float2 PixelOffsets[g_c_PixelOffsetSize] =
{
	{ -0.006, 0.0 },
	{ -0.005, 0.0 },
	{ -0.004, 0.0 },
	{ -0.003, 0.0 },
	{ -0.002, 0.0 },
	{ -0.001, 0.0 },
	{  0.000, 0.0 },
	{  0.001, 0.0 },
	{  0.002, 0.0 },	
	{  0.003, 0.0 },
	{  0.004, 0.0 },
	{  0.005, 0.0 },
	{  0.006, 0.0 },
};

float2 PixelOffset_fix = {0.008, 0.0};

static const float BlurWeights[g_c_PixelOffsetSize] =
{
	0.002216,
	0.008764,
	0.026995,
	0.064759,
	0.120985,
	0.176033,
	0.199471,
	0.176033,
	0.120985,
	0.064759,
	0.026995,
	0.008764,
	0.002216,
};

float4 main_PS(float2 texcoord0 : TEXCOORD0) : COLOR
{

	float4 pixel = 0;
	float4 color = 0;
	float depth = tex2D(depthSampler, texcoord0).x;
	float depth2 = 0;
	
	for(int i = 0; i < g_c_PixelOffsetSize; i++)
	{
		
		//pixel += 1 * tex2D(currentScene,(texcoord0-vecViewPort.zw+PixelOffset_fix) + PixelOffsets[i] * vecSkill1.x) * BlurWeights[i];	
		pixel = 1 * tex2D(currentScene,(texcoord0-vecViewPort.zw+PixelOffset_fix) + PixelOffsets[i] * vecSkill1.x * depth) * BlurWeights[i];	
		depth2 = 1 * tex2D(depthSampler,(texcoord0-vecViewPort.zw+PixelOffset_fix) + PixelOffsets[i] * vecSkill1.x * depth).x;

		if(depth2 - depth <= rayDepth
		&& depth2 - depth >= -rayDepth) color += pixel;
	}
	
	return color;
}


technique VBlur
{
	pass pass1
	{
		alphablendenable=false;
		Pixelshader = compile ps_3_0 main_PS();
	}
}
