
matrix matWorld;
matrix matWorldInv;
matrix matView;
matrix matViewInv;
matrix matViewProj;
matrix matProj;
matrix matWorldView;
matrix matWorldViewProj;

matrix matTangent;

float4 vecLightPos[8];
float4 vecViewPos;
float4 vecFog;

texture entSkin1;

sampler colorSampler = sampler_state
{
   texture = (entSkin1);
   MinFilter = linear;
   MagFilter = linear;
   MipFilter = linear;
   AddressU = Clamp;
   AddressV = Clamp;
};

texture entSkin3;

sampler normalSampler = sampler_state
{
   texture = (entSkin3);
   MinFilter = linear;
   MagFilter = linear;
   MipFilter = linear;
   AddressU = Clamp;
   AddressV = Clamp;
};

void LightsVS( 
   in float4 InPos: POSITION,
   in float3 InNormal: NORMAL,
   in float2 InTex : TEXCOORD0,
   in float3 InTangent : TEXCOORD2,
   out float2 OutTex : TEXCOORD0,
   out float3 OutNormal: TEXCOORD1,
   out float4 OutPos: POSITION
)
{
	OutPos = mul(InPos, matWorldViewProj); 
	float3 PosWorld = mul(InPos, matWorld);

	OutNormal = normalize(mul(InNormal, matWorldView));
	
	OutTex = InTex;
}

float4 LightsPS(float2 InTex : TEXCOORD0, float3 InNormal : TEXCOORD1):COLOR0
{
	float4 Color = 1;
	
	Color.rgb = InNormal;
	//Color.rgb = tex2D(normalSampler,InTex).rgb;
	Color.a = tex2D(colorSampler,InTex).a;
	if(Color.a < 1) clip(-1);
	
	return Color;
}

// Technique: 
technique DiffuseTechnique 
{ 
   pass P0 
   { 
   
   	//cullmode = CW;
   	//VertexShader = compile vs_2_0 DiffuseVS(); 
   	//PixelShader  = compile ps_2_0 DiffusePS(); 
   	VertexShader = compile vs_2_0 LightsVS(); 
      PixelShader  = compile ps_2_0 LightsPS(); 
		shademode = Flat;
   } 
}


/*
technique flatshade
{
	pass p0
	{
		shademode = Flat;	
	}
}
*/


/*   
struct a2v
{
	float4 Position: POSITION0;
   float3 Normal  : NORMAL;
};

struct v2f
{
   float4 Position: POSITION0;
   float  Test    : TEXCOORD0;
   float3 Normal  : TEXCOORD1;
};
        
struct f2s
{
	float4 Colour  : COLOR0;
};
        
void vp(in a2v IN, out v2f OUT)
{
   OUT.Position = mul(IN.Position, matWorldView);
   OUT.Test     = length(OUT.Position.xyz);
   OUT.Position = mul(IN.Position, matWorldViewProj);
   OUT.Normal   = mul(IN.Normal, matWorldView);
}
        
void fp(in v2f IN, out f2s OUT)
{
   float  Deep = IN.Test;
   float3 N    = normalize(IN.Normal);
   OUT.Colour = float4(N.r, N.g, N.b, Deep);
}
        
technique T1
{
	pass Pass0
   {
   	alphablendenable = false;
		VertexShader = compile vs_1_1 vp();
      PixelShader  = compile ps_2_0 fp();
   }
}
*/
