float4x4 matMtl;
float4x4 matWorld;

float4 vecViewPos;
float4 vecViewDir;
float4 vecViewPort;

texture sc_map_depth_bmap;

sampler depthSampler = sampler_state 
{ 
   Texture = <sc_map_depth_bmap>; 
   MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = LINEAR;
};


float decode(float4 vec)
{
		const float4 bitShifts = float4(1.0/(256.0*256.0*256.0), 1.0/(256.0*256.0), 1.0/256.0, 1);

		return dot(vec.xyzw , bitShifts);
}

float4 mainPS(float4 inTex:TEXCOORD0):COLOR0
{
	//get scene depth
	float depth = decode(tex2D(depthSampler,inTex.xy).wzyx);
	//depth = tex2D(depthSampler,inTex.xy).x;
	
	//compute world position
	float4 vp = float4(inTex.xy * float2(2, -2) - float2(1, -1), depth, 1);
   float4 v = mul(vp, matMtl);
   float3 position = v.xyz/v.w;
	
	//calculate normals from position
   float3 normal;
   normal = cross(ddx(position),ddy(position));
   	
	//camera-to-surface vector
   float3 directionToCamera = normalize(vecViewPos.xyz - position);
    
   //lighting
	float3 Ln = (float3(-70,150,20)- position);
 	float attenuation = saturate(1.0f - length(Ln)/500);
   Ln = normalize(Ln);
	float3 Nb = normalize(normal);
   float3 Vn = directionToCamera;
   float3 Hn = normalize(Vn + Ln);
   float4 lighting = lit(dot(Ln,Nb),dot(Hn,Nb),15);
	
	float4 color = 1;
	color.rgb = lighting.y;
	
	return color;
}

technique t1
{
	pass p0
	{
		PixelShader = compile ps_2_a mainPS();
	}
}