texture TargetMap;
texture mtlSkin1;
float4 vecSkill1;

sampler depthSampler = sampler_state
{
	texture = <TargetMap>;
	magfilter = LINEAR;
	minfilter = LINEAR;
	mipfilter= LINEAR;
	AddressU = clamp;
	AddressV = clamp;
};


sampler sceneSampler = sampler_state
{
	texture = <mtlSkin1>;
	magfilter = LINEAR;
	minfilter = LINEAR;
	mipfilter= LINEAR;
	AddressU = clamp;
	AddressV = clamp;
};

float4 blurDepth(float2 Tex : TEXCOORD0):COLOR0
{
	float depth = tex2D(depthSampler,Tex).x;
	float finalDepth = depth;
	float newDepth = 0;
	float blurDepth = 0.5;
	float blurStr = vecSkill1.x; // 0.0018;
	

	newDepth = tex2D(depthSampler,Tex+float2(blurStr,0)).x;
	if(newDepth < depth + blurDepth && newDepth > depth-blurDepth) finalDepth += newDepth;
	else finalDepth += depth;
	
	newDepth = tex2D(depthSampler,Tex+float2(0,blurStr)).x;
	if(newDepth < depth + blurDepth && newDepth > depth-blurDepth) finalDepth += newDepth;
	else finalDepth += depth;
	
	newDepth = tex2D(depthSampler,Tex+float2(-blurStr,0)).x;
	if(newDepth < depth + blurDepth && newDepth > depth-blurDepth) finalDepth += newDepth;
	else finalDepth += depth;
	
	newDepth = tex2D(depthSampler,Tex+float2(0,-blurStr)).x;
	if(newDepth < depth + blurDepth && newDepth > depth-blurDepth) finalDepth += newDepth;
	else finalDepth += depth;

	

	newDepth = tex2D(depthSampler,Tex+float2(blurStr/2,blurStr/2)).x;
	if(newDepth < depth + blurDepth && newDepth > depth-blurDepth) finalDepth += newDepth;
	else finalDepth += depth;
	
	newDepth = tex2D(depthSampler,Tex+float2(-blurStr/2,-blurStr/2)).x;
	if(newDepth < depth + blurDepth && newDepth > depth-blurDepth) finalDepth += newDepth;
	else finalDepth += depth;
	
	newDepth = tex2D(depthSampler,Tex+float2(-blurStr/2,blurStr/2)).x;
	if(newDepth < depth + blurDepth && newDepth > depth-blurDepth) finalDepth += newDepth;
	else finalDepth += depth;
	
	newDepth = tex2D(depthSampler,Tex+float2(blurStr/2,-blurStr/2)).x;
	if(newDepth < depth + blurDepth && newDepth > depth-blurDepth) finalDepth += newDepth;
	else finalDepth += depth;
	
	finalDepth /= 9;

	
	return float4(finalDepth,0,0,0);
	
}

/*
float4 blurDepthfallback(float2 Tex : TEXCOORD0):COLOR0
{
	float depth = tex2D(depthSampler,Tex).x;
	float finalDepth = depth;
	float newDepth = 0;
	float blurDepth = 0.5;
	float blurStr = vecSkill1.x; // 0.0018;
	

	newDepth = tex2D(depthSampler,Tex+float2(blurStr,0)).x;
	if(newDepth < depth + blurDepth && newDepth > depth-blurDepth) finalDepth += newDepth;
	else finalDepth += depth;
	
	newDepth = tex2D(depthSampler,Tex+float2(0,blurStr)).x;
	if(newDepth < depth + blurDepth && newDepth > depth-blurDepth) finalDepth += newDepth;
	else finalDepth += depth;
	
	newDepth = tex2D(depthSampler,Tex+float2(-blurStr,0)).x;
	if(newDepth < depth + blurDepth && newDepth > depth-blurDepth) finalDepth += newDepth;
	else finalDepth += depth;
	
	newDepth = tex2D(depthSampler,Tex+float2(0,-blurStr)).x;
	if(newDepth < depth + blurDepth && newDepth > depth-blurDepth) finalDepth += newDepth;
	else finalDepth += depth;

	finalDepth /= 5;
	
	//finalDepth = tex2D(depthSampler,Tex).x;
	
	return float4(finalDepth,0,0,0);
	
}
*/


float4 blurDepthfallback(float2 Tex : TEXCOORD0):COLOR0
{
	float2 depth = tex2D(depthSampler,Tex).xy;
	float finalDepth = tex2D(depthSampler,Tex).y;
	float2 newDepth = 0;
	float blurDepth = 0.000025;
	float blurStr = vecSkill1.x; // 0.0018;
	

	newDepth = tex2D(depthSampler,Tex+float2(blurStr,0)).xy;
	if(newDepth.x < depth.x + blurDepth && newDepth.x > depth.x-blurDepth) finalDepth += newDepth.y;
	else finalDepth += depth.y;
	
	newDepth = tex2D(depthSampler,Tex+float2(0,blurStr)).xy;
	if(newDepth.x < depth.x + blurDepth && newDepth.x > depth.x-blurDepth) finalDepth += newDepth.y;
	else finalDepth += depth.y;
	
	newDepth = tex2D(depthSampler,Tex+float2(-blurStr,0)).xy;
	if(newDepth.x < depth.x + blurDepth && newDepth.x > depth.x-blurDepth) finalDepth += newDepth.y;
	else finalDepth += depth.y;
	
	newDepth = tex2D(depthSampler,Tex+float2(0,-blurStr)).xy;
	if(newDepth.x < depth.x + blurDepth && newDepth.x > depth.x-blurDepth) finalDepth += newDepth.y;
	else finalDepth += depth.y;

	finalDepth /= 5;
	
	finalDepth = lerp(finalDepth,finalDepth*finalDepth,0.5);
	//finalDepth = tex2D(depthSampler,Tex).x;
	
	float3 color = tex2D(sceneSampler,Tex).xyz;
	color *= finalDepth;
	//color *= tex2D(depthSampler,Tex).g;
	//color *= tex2D(depthSampler,Tex);
	return float4(color,1);
	
}

/*
float4 blurDepthfallback(float2 Tex : TEXCOORD0):COLOR0
{
	float2 depth = tex2D(depthSampler,Tex).wy;
	float finalDepth = tex2D(depthSampler,Tex).y;
	float2 newDepth = 0;
	float blurDepth = 0.000025;
	float blurStr = vecSkill1.x; // 0.0018;
	float3 gi = 0;

	newDepth = tex2D(depthSampler,Tex+float2(blurStr,0)).wy;
	if(newDepth.x < depth.x + blurDepth && newDepth.x > depth.x-blurDepth)
	{
		finalDepth += newDepth.y;
		gi += tex2D(depthSampler,Tex+float2(blurStr,0)).xyz;
	}
	else finalDepth += depth.y;
	
	newDepth = tex2D(depthSampler,Tex+float2(0,blurStr)).wy;
	if(newDepth.x < depth.x + blurDepth && newDepth.x > depth.x-blurDepth)
	{
		finalDepth += newDepth.y;
		gi += tex2D(depthSampler,Tex+float2(0,blurStr)).xyz;
	}
	else finalDepth += depth.y;
	
	newDepth = tex2D(depthSampler,Tex+float2(-blurStr,0)).wy;
	if(newDepth.x < depth.x + blurDepth && newDepth.x > depth.x-blurDepth)
	{
		finalDepth += newDepth.y;
		gi += tex2D(depthSampler,Tex+float2(-blurStr,0)).xyz;
	}
	else finalDepth += depth.y;
	
	newDepth = tex2D(depthSampler,Tex+float2(0,-blurStr)).wy;
	if(newDepth.x < depth.x + blurDepth && newDepth.x > depth.x-blurDepth)
	{
		finalDepth += newDepth.y;
		gi += tex2D(depthSampler,Tex+float2(0,-blurStr)).xyz;
	}
	else finalDepth += depth.y;

	finalDepth /= 5;
	
	finalDepth = lerp(finalDepth,finalDepth*finalDepth,0.5);
	//finalDepth = tex2D(depthSampler,Tex).x;
	
	float3 color = tex2D(sceneSampler,Tex).xyz;
	color *= gi/4;
	//color *= tex2D(depthSampler,Tex).g;
	//color *= tex2D(depthSampler,Tex);
	return float4(color,1);
	
}
*/

/*
technique tBlurDepth
{
	pass p0
	{
		PixelShader = compile ps_2_a blurDepth();
	}
}
*/

technique fallback1
{
	pass p0
	{
		PixelShader = compile ps_2_0 blurDepthfallback();
	}
}

/*
technique fallback2
{
	pass p0
	{
		texture[0] = <TargetMap>;
	}
}
*/












static const int g_c_PixelOffsetSize = 13;

float2 PixelOffset_fix = {0.003, 0.003};

float2 PixelOffsets[g_c_PixelOffsetSize] = {
   0.0, 0.0,
   0.0, 1.5,
   1.5, 0.0,
   1.0, 1.0,
   0.0,-1.5,
  -1.5, 0.0,
  -1.0,-1.0,
  -1.0, 1.0,
   1.0,-1.0,
   0.5, 0.5,
   0.5,-0.5,
  -0.5,-0.5,
  -0.5, 0.5,

};

static const float BlurWeights[g_c_PixelOffsetSize] =
{
	0.176033,
	0.176033,
	0.176033,
	0.176033,
	0.176033,
	0.176033,
	0.176033,
	0.176033,
	0.176033,
	0.176033,
	0.176033,
	0.176033,
	0.176033,
};


float4 HorBloom_PS(float2 texcoord0 : TEXCOORD0) : COLOR
{

	float4 pixel = 0;
	vecSkill1.x = 0.004;
	for(int i = 0; i < g_c_PixelOffsetSize; i++)
	{
		pixel += 1 * tex2D(depthSampler,(texcoord0+PixelOffset_fix) + PixelOffsets[i] * vecSkill1.x) * BlurWeights[i];	
	}
	
	return pixel*tex2D(sceneSampler,texcoord0);
	
}
/*
technique tech_00
{
	pass pass_00
	{
		alphablendenable=false;
		Pixelshader = compile ps_2_0 HorBloom_PS();
	}
}
*/